
/*  DIALOG.C  - My first non-OWL dialog box.  */

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "bf.h"


extern HINSTANCE _hInstance;   /*  The global in the BC startup code.  */
char work1[128], work2[128];


/**********************    Loops Dialog    **********************/

#pragma argsused
BOOL CALLBACK LoopsCB(HWND hDlg, UINT message,
                      WPARAM wParam, LPARAM lParam)
{
int loops;

  switch (message) {

  case WM_INITDIALOG:            /* message: initialize dialog box */
    SendDlgItemMessage(hDlg, 101, WM_SETTEXT, 0, (LPARAM)(LPCSTR) work1);
    return(TRUE);

  case WM_COMMAND:               /* message: received a command */

    switch (wParam) {
    case IDOK:
      SendDlgItemMessage(hDlg, 101, WM_GETTEXT, 20, (LPARAM)(LPCSTR) work1);
      loops = atoi(work1);
      if (loops < 1 || loops > 100) {
        MessageBox(NULL,"You must enter a value between 1 and 100.",
                   "Input Error", MB_OK);
        return(TRUE);
      }
      EndDialog(hDlg, IDOK);    /* Exits the dialog box        */
      return(TRUE);
    case IDCANCEL:
      EndDialog(hDlg, IDCANCEL);    /* Exits the dialog box        */
      return(TRUE);
    }

    break;
  }

  return(FALSE);                 /* Didn't process a message    */
}


int Loops(HWND hwnd, int *loops)
{
DLGPROC dlgProcLoops;
int val;

  itoa(*loops, work1, 10);
  dlgProcLoops = (DLGPROC)MakeProcInstance((FARPROC)LoopsCB, _hInstance);
  val = DialogBox(_hInstance, "LoopsDialog", hwnd, dlgProcLoops);
  if (val == IDOK)
    *loops = atoi(work1);
  FreeProcInstance((FARPROC) dlgProcLoops);
  return val;
}



/**********************    Custom Dialog    **********************/

#pragma argsused
BOOL CALLBACK CustomCB(HWND hDlg, UINT message,
                       WPARAM wParam, LPARAM lParam)
{
int val=IDOK, mypoints;

  switch (message) {

  case WM_INITDIALOG:            /* message: initialize dialog box */
    SendDlgItemMessage(hDlg, 101, WM_SETTEXT, 0, (LPARAM)(LPCSTR) work1);
    SendDlgItemMessage(hDlg, 102, WM_SETTEXT, 0, (LPARAM)(LPCSTR) work2);
    return(TRUE);

  case WM_COMMAND:               /* message: received a command */

    switch (wParam) {
    case IDOK:
      SendDlgItemMessage(hDlg, 101, WM_GETTEXT, 128, (LPARAM)(LPCSTR) work1);
      SendDlgItemMessage(hDlg, 102, WM_GETTEXT, 128, (LPARAM)(LPCSTR) work2);
      mypoints = atoi(work2);
      if (mypoints < 3 || mypoints > 300 || work1[0] == 0) {
        MessageBox(NULL,"Be sure to specify some text to display, "
                   "and size should be between 10 and 300.",
                   "Input Error", MB_OK);
        return(TRUE);
      }
      if (mypoints > 128) {
        val = MessageBox(NULL,
                         "Windows doesn't handle fonts this large "
                         "real well, but you can try..",
                         "Alert", MB_OKCANCEL);
      }
      if (val == IDOK)
        EndDialog(hDlg, IDOK);    /* Exits the dialog box        */
      return(TRUE);
    case IDCANCEL:
      EndDialog(hDlg, IDCANCEL);    /* Exits the dialog box        */
      return(TRUE);
    }

    break;
  }

  return(FALSE);                 /* Didn't process a message    */
}


int Custom(HWND hwnd, LPCSTR str1, LPCSTR str2)
{
DLGPROC dlgProcCustom;
int val;

  _fstrcpy(work1, str1);
  _fstrcpy(work2, str2);
  dlgProcCustom = (DLGPROC)MakeProcInstance((FARPROC)CustomCB, _hInstance);
  val = DialogBox(_hInstance, "CustomDialog", hwnd, dlgProcCustom);
  if (val == IDOK) {
    _fstrcpy((char far *)str1, work1);
    _fstrcpy((char far *)str2, work2);
  }
  FreeProcInstance((FARPROC) dlgProcCustom);
  return val;
}

